package creim.analysis.audio.spotifyapi;



public class SpotifyAudioAnalysis {
	public class Meta {
		public String analyzer_version;
		public String platform;
		public String detailed_status;
		public long   status_code;
		public long   timestamp;
		public double analysis_time;
		public String input_process;
	}
	public class Beat {
		public double start;
		public double duration;
		public double confidence;
	}
	public class Bar {
		public double start;
		public double duration;
		public double confidence;	
	}
	public class Tatum {
		public double start;
		public double duration;
		public double confidence;	
	}
	public class Section {
		public double start;
		public double duration;
		public double confidence;
		public double loudness;
		public double tempo;
		public double tempo_confidence;
		public long   key;
		public double key_confidence;
		public long   mode;
		public double mode_confidence;
		public long   time_signature;
		public double time_signature_confidence;
	}
	public class Segment {
		public double start;
		public double duration;
		public double confidence;
		public double loudness_start;
		public double loudness_max_time;
		public double loudness_max;
		public double loudness_end;
		public double[] pitches;
		public double[] timbre;
	}
	public class Track {
		public long   num_samples;
		public double duration;
		public String sample_md5;
		public long   offset_seconds;
		public double window_seconds;
		public long   analysis_sample_rate;
		public double analysis_channels;
		public double end_of_fade_in;
		public double start_of_fade_out;
		public double loudness;
		public double tempo;
		public double tempo_confidence;
		public long   time_signature;
		public double time_signature_confidence;
		public long   key;
		public double key_confidence;
		public long   mode;
		public double mode_confidence;
		public String codestring;
		public double code_version;
		public String echoprintstring;
		public double echoprint_version;
		public String synchstring;
		public double synch_version;
		public String rhythmstring;
		public double rhythm_version;
	}
}
