package creim.analysis.audio.spotifyapi;

import java.io.File;
import java.nio.file.Files;



public class SpotifyCallbackWeb {
	
	private File htmlfile;
	
	public SpotifyCallbackWeb() {
		this.htmlfile = null;
	}
	
	public SpotifyCallbackWeb(File htmlfile) {
		if (htmlfile.exists()) {
			this.htmlfile = htmlfile;
		}
	}
	
	public byte[] getBytes() {
		if (htmlfile == null)
			return html.getBytes();
		
		try {
			return Files.readAllBytes(htmlfile.toPath());
		} catch (Exception e) {
			System.out.println("spotify html error: "+e.getMessage());
			return html.getBytes();
		}
	}
	
	
	private static final String html = "<!DOCTYPE html>"
	                                 + "<html>"
	                                 + "  <body style=\"background-color: #373737; color: #1ED760; font-family: 'Trebuchet MS', Helvetica, sans-serif;\">"
	                                 + "    <div align=\"center\">"
	                                 + "      <img src=\"https://developer.spotify.com/wp-content/uploads/2014/06/spotify-design.png\">"
	                                 + "    </div>"
	                                 + "    <div align=\"center\">"
	                                 + "      <h1>Close this.</h1>"
	                                 + "    </div>"
	                                 + "  </body>"
	                                 + "</html>";
}
