package creim.analysis.image;

import java.awt.image.BufferedImage;



public class ImageScale {
	
	private BufferedImage img;
	
	public ImageScale(BufferedImage img) {
		this.img = img;
	}
	
	
	public BufferedImage nearestNeighbor(int outwidth, int outheight) {
		BufferedImage out = new BufferedImage(outwidth, outheight, BufferedImage.TYPE_INT_ARGB);
		
		double xr = img.getWidth() / (double)outwidth;
		double yr = img.getHeight() / (double)outheight;
		
		int px, py;
		for (int x = 0; x < outwidth; x++) {
			for (int y = 0; y < outheight; y++) {
				px = (int)Math.floor(x * xr);
				py = (int)Math.floor(y * yr);
				out.setRGB(x, y, img.getRGB(px, py));
			}
		}
		
		return out;
	}

}
