/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creim.art;

import com.jhlabs.image.GaussianFilter;
import creim.art.painter.ClearPainter;
import creim.art.painter.Painter;
import creim.art.painter.StraightBrushPainter;
import creim.gui.ImageFrame;
import creim.graphics.colors.ColorPalette;
import creim.graphics.effect.BlurEffect;
import creim.graphics.effect.OilifyEffect;
import creim.util.Logger;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import javalib.util.Domain;
import javalib.util.RandomUtil;
import org.apache.commons.collections4.list.TreeList;

/**
 *
 * @author Viktor
 */
public class RandomArt {
	
	public BufferedImage generate(Dimension imagedim, boolean saveimage, boolean savejson) {
		// === general ===
		int margin = (int)(Math.max(imagedim.width, imagedim.height) * 0.1);
		
		// === color ===
		Color[] palette;
		double d = RandomUtil.nextDouble();
		if (d < 0.33) {
			palette = ColorPalette.generateRandomAdjacentPalette(RandomUtil.nextInt(0, 360), 15);
		} else if (d < 0.66) {
			palette = ColorPalette.generateRandomPalette();
		} else {
			palette = ColorPalette.getRandomPalette();
		}
		
		// === models ===
		int num_models = RandomUtil.nextInt(100);
		Logger.info("Painters: "+num_models);
		TreeList<Painter> models = new TreeList<>();
		for (int j = 0; j < num_models; j++) {
			Painter painter = Painter.randomPainter(imagedim, margin, palette);
			models.add(painter);
		}
		
		BufferedImage image = new BufferedImage(imagedim.width, imagedim.height, BufferedImage.TYPE_INT_ARGB);
		
//		ClearPainter cp = new ClearPainter(imagedim.width, imagedim.height, Color.black);
		ClearPainter cp = new ClearPainter(imagedim.width, imagedim.height, Color.WHITE);
		cp.paintOn(image);
		
		
		for (Painter painter : models) {
			painter.paintOn(image);
			Logger.info("Painter "+painter.getClass().getName());
		}
		
		OilifyEffect oil = new OilifyEffect(image, 5, 15);
		oil.applyInplace();

		BlurEffect blur = new BlurEffect(image, 1);
		blur.applyInplace();
		
//		// save gson
//		Gson gson = new GsonBuilder().setPrettyPrinting().create();
//		String json = gson.toJson(models);
//		System.out.println(json);
//		
//		models = gson.fromJson(json, TreeList.class);
//		System.out.println(models);
		
		return image;
	}
	
	
	
	
	public void generateStraightLineSet(Dimension imagedim, boolean saveimage, boolean savejson) throws Exception {
		int margin = (int)(Math.max(imagedim.width, imagedim.height) * 0.1);
		Domain linedomx = new Domain(-margin, imagedim.width+margin);
		Domain linedomy = new Domain(-margin, imagedim.height+margin);
		
			
		Color[] palette;
//		String[] names = {"WARM","COLD","SAD","HAPPY","ANGRY","PASTEL","CALM","ANGRY","AGRESSIVE"};
		
		int amount = 5;
		for (int i = 0; i < amount; i++) {
//			palette = ColorPalette.getRandomStartsWith(names[(int)(i/(double)amount * names.length)]);
			BufferedImage image = new BufferedImage(imagedim.width, imagedim.height, BufferedImage.TYPE_INT_ARGB);
			palette = ColorPalette.generateFullyRandomAdjacentPalette(0, RandomUtil.nextInt(0, 75), 1f,1f,1f,1f);
			
			boolean whitebg = RandomUtil.randBool(0.4);
			ClearPainter cp = new ClearPainter(imagedim, whitebg ? Color.white : palette[RandomUtil.nextInt(palette.length)]);
			cp.paintOn(image);
			
			boolean rotate = false;// RandomUtil.randBool(0.5);
			int bwmin = RandomUtil.nextInt((int)(linedomx.max * 0.05));
			int bwmax = RandomUtil.nextInt(bwmin, linedomx.max);
			Domain brushwidthdom = new Domain(bwmin, bwmax);
			
			int lines = RandomUtil.nextInt(100);
			for (int j = 0; j < lines; j++) {
				int x = RandomUtil.nextIntDomain(linedomx);
				int y = RandomUtil.nextIntDomain(linedomy);
				int brushwidth = RandomUtil.nextIntDomain(brushwidthdom);
				int length = RandomUtil.nextInt((int)(Math.max(imagedim.width, imagedim.height) * 1.5));
				Color brushcolor = palette[RandomUtil.nextInt(palette.length)];
				double rotation;
				if (rotate)
					rotation = RandomUtil.nextDouble(0, 360);
				else
					rotation = 0;
				StraightBrushPainter painter = new StraightBrushPainter(x, y, brushwidth, length, brushcolor, rotation);
				painter.paintOn(image);
			}
			
			OilifyEffect oil = new OilifyEffect(image, 5, 15);
			oil.applyInplace();

			GaussianFilter filter = new GaussianFilter(5);
			filter.filter(image, image);
			
			ImageFrame frame = new ImageFrame(image);
			frame.setVisible(true);
		}
		
	}
	
}
