package creim.art.artist.description;

import creim.art.artist.Artist;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import javalib.util.RandomUtil;
import creim.business.Description;



public class Boxes extends Artist {
	
	private Description desc;
	
	public Boxes(int width, int height, Description description) {
		super(width, height);
		this.desc = description;
	}
	
	
	
	@Override
	public BufferedImage paint() {
		Graphics2D g = (Graphics2D)image.getGraphics();
		g.setStroke(new BasicStroke(0.01f * Math.min(width, height)));
		
		int squarecount = RandomUtil.nextInt(desc.boxesCountDom.min, desc.boxesCountDom.max);
		
		Color bg = desc.palette[RandomUtil.nextInt(desc.palette.length)];
		
		g.setColor(bg);
		g.fillRect(0, 0, width, height);
//		for (int xt = 0; xt < width; xt++) {
//			for (int yt = 0; yt < height; yt++) {
//				int x = xt;
//				int y = yt;
//				if (x < 0 || x >= width || y < 0 || y >= height)
//					continue;
//
//				double n = CloudEffect.noise(xt*4/(double)width, yt*4/(double)height);
//
//				int current  = image.getRGB(x, y);
//				int tomix    = new Color(255, 255, 255, (int)(n*255)).getRGB();
//				int newcolor = ColorUtil.mixNorm(current, tomix);
//
//				image.setRGB(x, y, newcolor);
//			}
//		}
		
		
		for (int i = 0; i < squarecount; i++) {
			int rw = RandomUtil.nextInt(desc.boxesMinDim.width, desc.boxesMaxDim.width);
			int rh = RandomUtil.nextInt(desc.boxesMinDim.height, desc.boxesMaxDim.height);
			int rx = RandomUtil.nextInt(width) - rw/2;
			int ry = RandomUtil.nextInt(height) - rh/2;
			Color c = desc.palette[RandomUtil.nextInt(desc.palette.length)];
			
			g.setColor(c);
			g.fillRect(rx, ry, rw, rh);
			
//			for (int xt = 0; xt < rw; xt++) {
//				for (int yt = 0; yt < rh; yt++) {
//					int x = xt+rx;
//					int y = yt+ry;
//					if (x < 0 || x >= width || y < 0 || y >= height)
//						continue;
//					
//					double n = CloudEffect.noise(xt/(double)rw, yt/(double)rh);
//					
//					int current  = image.getRGB(x, y);
//					int tomix    = ((int)(n*255) << 24);// | (255 << 16) | (255 << 8) | (255);
//					int newcolor = ColorUtil.mixNorm(current, tomix);
//					
//					image.setRGB(x, y, newcolor);
//					
////					int rgb = 255 << 24 - (int)(n*255) << 24; // magic result!
////					image.setRGB(x, y, curr - rgb);
//					
//				}
//			}
//			CloudEffect.reset();
			if (squarecount <= 5) {
				g.setColor(Color.BLACK);
				g.drawRect(rx, ry, rw, rh);
			}
		}

		g.dispose();
		
		
//		CloudEffect ce = new CloudEffect(image, 150);
//		image = ce.apply();
//		
//		OilifyEffect oe = new OilifyEffect(image, 5, 25);
//		image = oe.apply();
//		
//		BlurEffect be = new BlurEffect(image, 4);
//		image = be.apply();
		
		return image;
	}

	
	
	
//	public Boxes(int width, int height, AudioFeatures features) {
//		super(width, height);
//		String prefix;
//		
//		palette = Palette.Spa_Earth;
//		
//		double valence = features.spotifyfeatures.valence;
//		if (valence < 0.3) {
//			prefix = "sad";
//		} 
//		else if (valence < 0.5) {
//			prefix = "pastel";
//		} 
//		else if (valence < 0.7) {
//			prefix = "love";
//		} 
//		else {
//			prefix = "happy";
//		}
//		
//		try {
//			palette = Palette.getRandomStartsWith(prefix);
//		} catch (Exception e) {
//			throw new RuntimeException("NOPE!");
//		}
//		
//		double energy = features.spotifyfeatures.energy;
//		outline = false;
//		squaremin = new Dimension(10, 10);
//		if (energy < 0.3) {
//			squares = new Domain(1, 5);
//			squaremax = new Dimension(width/2, height);
//			squaremin = new Dimension(50, 50);
//			outline = true;
//		} 
//		else if (energy < 0.5) {
//			squares = new Domain(5, 10);
//			squaremax = new Dimension(width/4, height);
//			outline = true;
//		} 
//		else if (energy < 0.7) {
//			squares = new Domain(10, 30);
//			squaremax = new Dimension(width/8, height);
//		} 
//		else {
//			squares = new Domain(60, 160);
//			squaremax = new Dimension(width/4, height);
//		}
//		
//		
//		
//	}

	
	
//	@Override
//	public BufferedImage paint(Description description) {
//		Graphics2D g = (Graphics2D)image.getGraphics();
//		g.setStroke(new BasicStroke(0.01f * Math.min(width, height)));
//
//		int squarecount = RandomUtil.nextInt(squares.min, squares.max);
//		
//		Color bg = palette[RandomUtil.nextInt(palette.length)];
//		g.setColor(bg);
//		g.fillRect(0, 0, width, height);
//		for (int xt = 0; xt < width; xt++) {
//			for (int yt = 0; yt < height; yt++) {
//				int x = xt;
//				int y = yt;
//				if (x < 0 || x >= width || y < 0 || y >= height)
//					continue;
//
//				double n = CloudEffect.noise(xt/(double)width, yt/(double)height);
//
//				int current  = image.getRGB(x, y);
//				int tomix    = (int)(n*255) << 24;
//				int newcolor = ColorUtil.mixAvg(current, tomix);
//
//				image.setRGB(x, y, newcolor);
//
////				int rgb = 255 << 24 - (int)(n*255) << 24; // magic result!
////				image.setRGB(x, y, curr - rgb);
//
//			}
//		}
//		
//		
//		for (int i = 0; i < squarecount; i++) {
//			int rw = RandomUtil.nextInt(squaremin.width, squaremax.width);
//			int rh = RandomUtil.nextInt(squaremin.height, squaremax.height);
//			int rx = RandomUtil.nextInt(width) - rw/2;
//			int ry = RandomUtil.nextInt(height) - rh/2;
//			Color c = palette[RandomUtil.nextInt(palette.length)];
//			
//			g.setColor(c);
//			g.fillRect(rx, ry, rw, rh);
//			
//			for (int xt = 0; xt < rw; xt++) {
//				for (int yt = 0; yt < rh; yt++) {
//					int x = xt+rx;
//					int y = yt+ry;
//					if (x < 0 || x >= width || y < 0 || y >= height)
//						continue;
//					
//					double n = CloudEffect.noise(xt/(double)rw, yt/(double)rh);
//					
//					int current  = image.getRGB(x, y);
//					int tomix    = (int)(n*255) << 24;
//					int newcolor = ColorUtil.mixAvg(current, tomix);
//					
//					image.setRGB(x, y, newcolor);
//					
////					int rgb = 255 << 24 - (int)(n*255) << 24; // magic result!
////					image.setRGB(x, y, curr - rgb);
//					
//				}
//			}
//			CloudEffect.reset();
//			if (outline) {
//				g.setColor(Color.BLACK);
//				g.drawRect(rx, ry, rw, rh);
//			}
//		}
//		
//		g.dispose();
//		
//		return image;
//	}	
}
