package creim.art.artist.ea;

import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;
import creim.art.artist.ea.fitnesscalculators.ComboDistanceFitnessCalculator;
import creim.art.artist.ea.fitnesscalculators.DescriptionDistanceFitnessCalculator;
import creim.art.artist.ea.fitnesscalculators.FitnessCalculator;
import creim.art.artist.ea.fitnesscalculators.ImageAnalysisFitnessCalculator;
import creim.art.artist.ea.fitnesscalculators.TargetDistanceFitnessCalculator;
import eval.models.Genotype;
import eval.models.Phenotype;
import java.awt.Dimension;

/**
 * 
 * @author Viktor
 */
public class ArtistPhenotype extends Phenotype {

	private Dimension imagedim;
	private SpotifyAudioFeatures[] features;
	private ArtistGenotype artistGenotype;
	
	
	public ArtistPhenotype(Genotype g, Dimension imagedim, SpotifyAudioFeatures[] features) {
		super(g);
		this.artistGenotype = (ArtistGenotype) g;
		this.features = features;
		this.imagedim = imagedim;
	}
	
	
	
	@Override
	protected double calculateFitness() {
//		FitnessCalculator calculator = new TargetDistanceFitnessCalculator(genotype, imagedim, features);
//		FitnessCalculator calculator = new DescriptionDistanceFitnessCalculator(genotype, imagedim, features);
		FitnessCalculator calculator = new ComboDistanceFitnessCalculator(genotype, imagedim, features);
//		FitnessCalculator calculator = new ImageAnalysisFitnessCalculator(genotype, imagedim, features);
		
		return calculator.calculateFitness();
	}
	


	@Override
	public String toString() {
		return artistGenotype.toString();
	}
	

	
}
