package creim.art.artist.ea;

import creim.util.DomainInt;
import creim.util.DomainFloat;
import javalib.util.RandomUtil;

/**
 *
 * @author Viktor
 */
public enum FeatureVariable {
	// Spotify Related
	danceability,
	energy,
	key,
	loudness,
	mode,
	speechiness,
	acousticness,
	instrumentalness,
	liveness,
	valence,
	tempo,
	
	// Unrelated
	RANDOM_GENERATOR,
//	NOT_DEFINED,
	
	// Image related
	
	;
	
	
	public static DomainFloat getInputDomain(FeatureVariable var) {
		if (var == null)
			return null;
		
		switch (var) {
			case danceability:      return new DomainFloat(0, 1);
			case energy:            return new DomainFloat(0, 1);
			case key:               return new DomainFloat(0, 11);
			case loudness:          return new DomainFloat(-60, 0);
			case mode:              return new DomainFloat(0, 1);
			case speechiness:       return new DomainFloat(0, 1);
			case acousticness:      return new DomainFloat(0, 1);
			case instrumentalness:  return new DomainFloat(0, 1);
			case liveness:          return new DomainFloat(0, 1);
			case valence:           return new DomainFloat(0, 1);
			case tempo:             return new DomainFloat(30, 200);
			
			case RANDOM_GENERATOR:  return new DomainFloat(0, 1);
//			case NOT_DEFINED:       return new DomainFloat(0, 1);
			default: 
				throw new UnsupportedOperationException("Missing input domain");
		}
	}
	
	
//	public static FeatureVariable randomNumericVariable() {
//		FeatureVariable[] vars = FeatureVariable.values();
//		return vars[RandomUtil.nextInt(vars.length-1)];
//	}
	
	
	public static FeatureVariable randomNumericVariable() {
		FeatureVariable[] vars = {danceability, energy, loudness, speechiness, acousticness, instrumentalness, valence, tempo};
		return vars[RandomUtil.nextInt(vars.length)];
	}
}
