/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creim.art.artist.ea.fitnesscalculators;

import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;
import creim.art.artist.ea.ArtistGenotype;
import creim.art.artist.ea.FeatureVariable;
import creim.art.artist.ea.GenotypeEntry;
import creim.art.artist.ea.MappingArtist;
import creim.art.artist.ea.ToolParameter;
import static creim.art.artist.ea.fitnesscalculators.TargetDistanceFitnessCalculator.KEY_MATCH_MULT;
import static creim.art.artist.ea.fitnesscalculators.TargetDistanceFitnessCalculator.KEY_MISMATCH_MULT;
import static creim.art.artist.ea.fitnesscalculators.TargetDistanceFitnessCalculator.KEY_NOT_DEFINED_MULT;
import static creim.art.artist.ea.fitnesscalculators.TargetDistanceFitnessCalculator.NO_RANDOM_GENERATOR;
import creim.art.painter.Painter;
import creim.graphics.colors.ColorDistance;
import creim.util.Logger;
import eval.models.Genotype;
import java.awt.Color;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Viktor
 */
public class ComboDistanceFitnessCalculator extends FitnessCalculator {
	
	public static final int STROKES = 10;
	public static ArtistGenotype targetgenotype = new ArtistGenotype(){{
//		map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 100, 300));
		map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.tempo, 0, 900));
		map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.tempo, 0, 900));
		map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.tempo, 0, 900));
		map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.tempo, 0, 900));
		map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 0));
		map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 360));
		map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 0));
		map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));	
	}};
	public static Map<String, Description> expectedmap = new HashMap<String, Description>(){{
		put("---Description based on survey 5---", null);
		put("spotify:track:5ChkMS8OtdzJeqyybCc9R5", new Description(new Color(  0, 196,  22),  10,  0.5,  9 * STROKES));
		put("spotify:track:5pD9x23lsoQr464mlmaKNJ", new Description(new Color(255, 216,  81),  10,  0.1,  6 * STROKES));
		put("spotify:track:2L8ZiTLLejiY9O7qhhoday", new Description(new Color(  0, 148, 255),  10,  0.1,  3 * STROKES));
		put("spotify:track:5f2CgxUSiRtuEMcY6mmAW4", new Description(new Color(214, 127, 255),  40,  0.7,  9 * STROKES));
		put("spotify:track:2iNRom9yU8lY7SEw6JCiBA", new Description(new Color(127, 201, 255),  10,  0.1,  2 * STROKES));
		put("spotify:track:6qTJtlUrLTrZLUuS81SPI7", new Description(new Color(255, 106,   0),  10,  0.1,  6 * STROKES));
	}};
//	public static Map<String, Description> expectedmap = new HashMap<String, Description>(){{
//		put("---Description based on survey 2---", null);
//		put("spotify:track:5ChkMS8OtdzJeqyybCc9R5", new Description(new Color(178,   0, 255),  10,  0.1,  3 * STROKES));
//		put("spotify:track:5pD9x23lsoQr464mlmaKNJ", new Description(new Color(255, 150,  81),  10,  0.5,  8 * STROKES));
//		put("spotify:track:2L8ZiTLLejiY9O7qhhoday", new Description(new Color(  0, 148, 255),   5,  0.1,  2 * STROKES));
//		put("spotify:track:5f2CgxUSiRtuEMcY6mmAW4", new Description(new Color(  0, 255,  33),  10,  0.7,  7 * STROKES));
//		put("spotify:track:2iNRom9yU8lY7SEw6JCiBA", new Description(new Color( 87,   0, 127),  10,  0.1,  6 * STROKES));
//		put("spotify:track:6qTJtlUrLTrZLUuS81SPI7", new Description(new Color(165, 255, 127),  40,  0.1,  8 * STROKES));
//	}};
	
	private final Dimension imagedim;
	private final SpotifyAudioFeatures[] features;
	private final ArtistGenotype artistGenotype;
	private MappingArtist artist;
	
	
	public ComboDistanceFitnessCalculator(Genotype g, Dimension imagedim, SpotifyAudioFeatures[] features) {
		this.artistGenotype = (ArtistGenotype) g;
		this.features = features;
		this.imagedim = imagedim;
	}
	
	
	@Override
	public double calculateFitness() {
		double fitnesssum = 0;
		for (int i = 0; i < features.length; i++) {
			artist = new MappingArtist(imagedim, features[i], artistGenotype, false);

			ArrayList<Painter> painters = artist.painters;
			Color[] palette = artist.palette;
			Color palettebase = palette[2];
			
			ArtistGenotype geno = artist.genotype;
			Logger.debug(artist.genotype);
			Description expected = expectedmap.get(features[i].uri);
			
			int strokesdiff = Math.abs(expected.strokes - artist.strokes);
			int colordistdiff = Math.abs(expected.colordist - artist.colordist);
			double shades = Math.abs(expected.shade - Math.abs(artist.colorsmax - artist.colorsmin) + Math.abs(artist.colorbmax - artist.colorbmin));
			
			fitnesssum += distanceExpectedParams() + colorDistance(palettebase, expected.base) + colordistdiff + strokesdiff + shades;
		}

		double avg = fitnesssum / features.length;
		return avg;
	}
	
	
	public double colorPaletteDistanceStrict(Color[] palette, Color[] expected) {
		assert palette.length == expected.length;
		
		double distsum = 0;
		for (int i = 0; i < palette.length; i++) {
			Color p = palette[i];
			Color e = expected[i];
			double dist = ColorDistance.weighted(p, e);
			
			distsum += dist;
		}
		
		return distsum;
	}

	
	
	public double colorDistance(Color palettebase, Color expectedbase) {
		double dist = ColorDistance.weighted(palettebase, expectedbase);
		return dist;
	}
	
	
	public double distanceExpectedParams() {
		double distsum = 0;
		for (ToolParameter param : targetgenotype.map.keySet()) {
			distsum += dist(param);
		}
		return distsum;
	}
	
	
	public double dist(ToolParameter param) {
		GenotypeEntry target = targetgenotype.getEntry(param);
		GenotypeEntry current = artist.genotype.getEntry(param);
		
		if (target == null)
			return 0;
		
		double mult;
		if (target.variable == current.variable) 
			mult = KEY_MATCH_MULT;
		else if (target.variable == FeatureVariable.RANDOM_GENERATOR && NO_RANDOM_GENERATOR)
			mult = KEY_MISMATCH_MULT;
		else if (target.variable == null)
			mult = KEY_NOT_DEFINED_MULT;
		else
			mult = KEY_MISMATCH_MULT;
		
		double min = Math.abs(target.outputmin - current.outputmin);
		double max = Math.abs(target.outputmax - current.outputmax);
		
		if (target.ignoreoutputmin)
			min = 0;
		if (target.ignoreoutputmax)
			max = 0;
		
		double dist = min + max;
		if (dist == 0 && mult != 1)
			return mult;
		return dist * mult;
	}
}
