/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package creim.art.artist.ea.fitnesscalculators;

import creim.analysis.audio.spotifyapi.SpotifyAudioFeatures;
import creim.art.artist.ea.ArtistGenotype;
import creim.art.artist.ea.MappingArtist;
import creim.art.painter.Painter;
import creim.graphics.colors.ColorDistance;
import creim.util.Logger;
import eval.models.Genotype;
import java.awt.Color;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author Vikto
 */
public class DescriptionDistanceFitnessCalculator extends FitnessCalculator {

//	public static Map<String, Color[]> expectedmap = new HashMap<String, Color[]>(){{
//		put("spotify:track:5ChkMS8OtdzJeqyybCc9R5", new Color[]{new Color(255,0,255), new Color(255,0,128), new Color(255,0,0), new Color(255,128,0), new Color(255,255,0)});
//		put("spotify:track:2iNRom9yU8lY7SEw6JCiBA", new Color[]{new Color(0,0,255), new Color(0,80,255), new Color(0,128,255), new Color(0,200,255), new Color(0,255,255)});
//	}};
	
	public static final int strokes = 10;
	public static Map<String, Description> expectedmap = new HashMap<String, Description>(){{
		put("---Description based on survey 2---", null);
		put("spotify:track:5ChkMS8OtdzJeqyybCc9R5", new Description(new Color(178,   0, 255),  10,  0.1,  3 * strokes));
		put("spotify:track:5pD9x23lsoQr464mlmaKNJ", new Description(new Color(255, 150,  81),  10,  0.5,  8 * strokes));
		put("spotify:track:2L8ZiTLLejiY9O7qhhoday", new Description(new Color(  0, 148, 255),   5,  0.1,  2 * strokes));
		put("spotify:track:5f2CgxUSiRtuEMcY6mmAW4", new Description(new Color(  0, 255,  33),  10,  0.7,  7 * strokes));
		put("spotify:track:2iNRom9yU8lY7SEw6JCiBA", new Description(new Color( 87,   0, 127),  10,  0.1,  6 * strokes));
		put("spotify:track:6qTJtlUrLTrZLUuS81SPI7", new Description(new Color(165, 255, 127),  40,  0.1,  8 * strokes));
	}};
	
	private final Dimension imagedim;
	private final SpotifyAudioFeatures[] features;
	private final ArtistGenotype artistGenotype;
	private MappingArtist artist;
	
	
	public DescriptionDistanceFitnessCalculator(Genotype g, Dimension imagedim, SpotifyAudioFeatures[] features) {
		this.artistGenotype = (ArtistGenotype) g;
		this.features = features;
		this.imagedim = imagedim;
	}
	
	
	@Override
	public double calculateFitness() {
		double fitnesssum = 0;
		for (int i = 0; i < features.length; i++) {
			artist = new MappingArtist(imagedim, features[i], artistGenotype, false);

			ArrayList<Painter> painters = artist.painters;
			Color[] palette = artist.palette;
			Color palettebase = palette[2];
			
			ArtistGenotype geno = artist.genotype;
			Logger.debug(artist.genotype);
			Description expected = expectedmap.get(features[i].uri);
			
			int strokesdiff = Math.abs(expected.strokes - artist.strokes);
			int colordistdiff = Math.abs(expected.colordist - artist.colordist);
			double shades = Math.abs(expected.shade - Math.abs(artist.colorsmax - artist.colorsmin) + Math.abs(artist.colorbmax - artist.colorbmin));
			
			fitnesssum += colorDistance(palettebase, expected.base) + colordistdiff + strokesdiff + shades;
		}

		double avg = fitnesssum / features.length;
		return avg;
	}
	
	
	public double colorPaletteDistanceStrict(Color[] palette, Color[] expected) {
		assert palette.length == expected.length;
		
		double distsum = 0;
		for (int i = 0; i < palette.length; i++) {
			Color p = palette[i];
			Color e = expected[i];
			double dist = ColorDistance.weighted(p, e);
			
			distsum += dist;
		}
		
		return distsum;
	}
	
	
	public double colorPaletteDistance(Color[] palette, Color[] expected) {
		assert palette.length == expected.length;
		
		
		
		double distsum = 0;
		for (int i = 0; i < palette.length; i++) {
			Color p = palette[i];
			Color e = expected[i];
			double dist = ColorDistance.weighted(p, e);
			
			distsum += dist;
		}
		
		return distsum;
	}
	
	
	public double colorDistance(Color palettebase, Color expectedbase) {
		double dist = ColorDistance.weighted(palettebase, expectedbase);
		return dist;
	}
	
}
