package creim.art.artist.ea.fitnesscalculators;

import creim.art.artist.ea.ArtistGenotype;
import creim.art.artist.ea.FeatureVariable;
import creim.art.artist.ea.GenotypeEntry;
import creim.art.artist.ea.ToolParameter;
import creim.util.Logger;
import java.util.Set;
import javalib.util.RandomUtil;

/**
 *
 * @author Vikto
 */
public class FitnessTarget {

	public static ArtistGenotype genotype = null;
	
	
	public static void load(ArtistGenotype target) {
		genotype = (ArtistGenotype) target.copy();
	}
	
	
	public static void loadHardCoded() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 20, 100));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 20));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
	}
	
	public static void loadHardCoded2() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 100));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 50));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
	}
	
	public static void loadHardCoded3() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.tempo, 100, 10));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.loudness, 0, 100));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.tempo, 0, 500));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.loudness, 0, 100));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
	
	public static void loadHardCoded4() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 100, 300));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
//		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
	
	public static void loadHardCoded5() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
	
	public static void loadHardCodedNoveltyNoKeys() {
		genotype = new ArtistGenotype();
	}
	
	public static void loadHardCodedNovelty() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
//		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
//		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
//		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
//		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
//		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.loudness, 0, 900));
//		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
//		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

//		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
//		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
//		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
	
	public static void loadHardCodedFreeColor() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(null, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(null, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
	
	public static void loadHardCodedFreeColorValue() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 0, 0, true, true));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 0, true, true));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
	
	public static void loadHardCodedIgnoreRandom(int ignorecount) {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
		
		for (int i = 0; i < ignorecount; i++) {
			Set<ToolParameter> keyset = genotype.map.keySet();
			int index = RandomUtil.nextInt(keyset.size());
			int j = 0;
			for (ToolParameter key : keyset) {
				if (j++ == index) {
					Logger.debug("Removing "+key+" from target genotype");
					keyset.remove(key);
					break;
				}
			}
		}
	}
	
	public static void loadHardCodedFreeVariables() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(null, 240, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(null, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(null, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(null, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(null, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(null, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(null, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(null, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(null, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(null, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(null, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(null, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(null, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(null, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(null, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(null, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(null, 7, 2));
	}
	
//======================================================================================================================================
	
	public static void loadHardCodedTesting() {
		genotype = new ArtistGenotype();
		genotype.map.put(ToolParameter.ColorDeg,  new GenotypeEntry(FeatureVariable.energy, 270, 0));
		genotype.map.put(ToolParameter.ColorDist, new GenotypeEntry(FeatureVariable.valence, 0, 90));
		genotype.map.put(ToolParameter.ColorSMin, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorSMax, new GenotypeEntry(FeatureVariable.loudness, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMax, new GenotypeEntry(FeatureVariable.valence, 0.9f, 1.0f));
		genotype.map.put(ToolParameter.ColorBMin, new GenotypeEntry(FeatureVariable.valence, 0.0f, 0.5f));
		
		genotype.map.put(ToolParameter.StraightBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 200));
		genotype.map.put(ToolParameter.StraightBrushWidthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushWidthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMin, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushLengthMax, new GenotypeEntry(FeatureVariable.RANDOM_GENERATOR, 0, 900));
		genotype.map.put(ToolParameter.StraightBrushRotationMin, new GenotypeEntry(FeatureVariable.danceability, 0, 270));
		genotype.map.put(ToolParameter.StraightBrushRotationMax, new GenotypeEntry(FeatureVariable.danceability, 0, 270));

		genotype.map.put(ToolParameter.CurveBrushStrokes, new GenotypeEntry(FeatureVariable.tempo, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMin, new GenotypeEntry(FeatureVariable.energy, 0, 10));
		genotype.map.put(ToolParameter.CurveBrushWidthMax, new GenotypeEntry(FeatureVariable.energy, 10, 20));
		
		genotype.map.put(ToolParameter.BlurEffect, new GenotypeEntry(FeatureVariable.energy, 7, 2));
	}
}
