package creim.art.models;

import java.awt.Color;
import java.awt.Dimension;
import javalib.util.RandomUtil;
import creim.oldea.EAMutable;



public class SquareModel extends PainterModel implements EAMutable {
	
	public int x;
	public int y;
	public int w;
	public int h;
	public Color color = Color.WHITE;
	public Color outlineColor = Color.BLACK;
	public float outlineThickness;

	public SquareModel() {
	}

	public SquareModel(int x, int y, int w, int h, float outlineThickness) {
		this.x = x;
		this.y = y;
		this.w = w;
		this.h = h;
		this.outlineThickness = outlineThickness;
	}
	
	
	@Override
	public void randomize() {
		x = RandomUtil.nextInt(-margin, imagedim.width + margin);
		y = RandomUtil.nextInt(-margin, imagedim.height + margin);
		w = RandomUtil.nextInt(-margin, imagedim.width + margin);
		h = RandomUtil.nextInt(-margin, imagedim.height + margin);
		color = palette[RandomUtil.nextInt(palette.length)];
		outlineColor = palette[RandomUtil.nextInt(palette.length)];
		outlineThickness = RandomUtil.nextInt(5);
	}
	
	

	@Override
	public void mutate(Dimension imagedim, Color[] palette, int margin) {
		int p = RandomUtil.nextInt(7);
		if (p == 0)
			x = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 1)
			y = RandomUtil.nextInt(-margin, imagedim.height + margin);
		else if (p == 2)
			w = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 3)
			h = RandomUtil.nextInt(-margin, imagedim.height + margin);
		else if (p == 4)
			color = palette[RandomUtil.nextInt(palette.length)];
		else if (p == 5)
			outlineColor = palette[RandomUtil.nextInt(palette.length)];
		else if (p == 6)
			outlineThickness = RandomUtil.nextInt(5);
	}
}
