package creim.art.models;

import java.awt.Color;
import java.awt.Dimension;
import javalib.util.RandomUtil;
import creim.oldea.EAMutable;



public class StraightBrushModel extends PainterModel implements EAMutable {
	
	public int x;
	public int y;
	public int brushwidth;
	public int length;
	public Color brushcolor;
	public double rotationdegrees;

	public StraightBrushModel() {
	}

	public StraightBrushModel(int x, int y, int brushwidth, int length, Color brushcolor, double rotationdegrees) {
		this.x = x;
		this.y = y;
		this.brushwidth = brushwidth;
		this.length = length;
		this.brushcolor = brushcolor;
		this.rotationdegrees = rotationdegrees;
	}

	@Override
	public void randomize() {
		paletteIndex = RandomUtil.nextInt(palette.length);
		
		x = RandomUtil.nextInt(-margin, imagedim.width + margin);
		y = RandomUtil.nextInt(-margin, imagedim.height + margin);
		brushwidth = RandomUtil.nextInt(100);
		length = RandomUtil.nextInt(imagedim.height + margin);
		brushcolor = palette[paletteIndex];
		rotationdegrees = RandomUtil.nextInt(360);
	}
	
	@Override
	public void mutate(Dimension imagedim, Color[] palette, int margin) {
		int p = RandomUtil.nextInt(6);
		if (p == 0)
			x = RandomUtil.nextInt(-margin, imagedim.width + margin);
		else if (p == 1)
			y = RandomUtil.nextInt(-margin, imagedim.height + margin);
		else if (p == 2)
			brushwidth = RandomUtil.nextInt(100);
		else if (p == 3)
			length = RandomUtil.nextInt(imagedim.height + margin);
		else if (p == 4)
			brushcolor = palette[RandomUtil.nextInt(palette.length)];
		else if (p == 5)
			rotationdegrees = RandomUtil.nextInt(360);
	}
	
}
