package creim.art.painter;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.awt.Dimension;



public class ClearPainter extends Painter {

	public int width;
	public int height;
	public boolean white;
	public Color backgroundcolor;
	
	public ClearPainter(int width, int height) {
		this(width, height, Color.WHITE);
	}
	
	public ClearPainter(int width, int height, Color backgroundcolor) {
		this(new Dimension(width, height), backgroundcolor);
	}
	
	public ClearPainter(Dimension imagedim, Color backgroundcolor) {
		this.width = imagedim.width;
		this.height = imagedim.height;
		this.backgroundcolor = backgroundcolor;
	}
	

	@Override
	public BufferedImage paint() {
		BufferedImage canvas = new BufferedImage(width, height, BufferedImage.TYPE_INT_ARGB);
		paintOn(canvas);
		return canvas;
	}

	
	@Override
	public void paintOn(BufferedImage image) {
		Graphics2D g2 = (Graphics2D)image.getGraphics();
		g2.setColor(backgroundcolor);
		g2.fillRect(0, 0, width, height);
	}

	@Override
	public void randomize() {
		throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
	}

	@Override
	public void mutate(Dimension imagedim, Color[] palette, int margin) {
		throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
	}

	@Override
	public double[] centerPoint() {
		return new double[]{width/2.0, height/2.0};
	}

	@Override
	public double area() {
		return width * height;
	}
}
