package creim.business;

import java.awt.Dimension;
import java.awt.Point;
import javalib.util.MathUtil;
import creim.analysis.audio.AudioAnalysisResult;
import creim.graphics.colors.ColorPalette;
import creim.graphics.colors.RYBColorWheel;
import javalib.util.Domain;



public class DescriptionCreator {

	
	public AudioAnalysisResult features;
	public Dimension imagedim;
	
	public DescriptionCreator (AudioAnalysisResult features, Dimension imagedim) {
		this.features = features;
		this.imagedim = imagedim;
	} 
	
	
	public Description createDescription() {
		Description d = new Description();
		
		int iw = imagedim.width;
		int ih = imagedim.height;
		
		double enrg = features.spotifyanalysis.energy;
		double loud = features.spotifyanalysis.loudness;
		
		d.useboxes = true;
		int boxes = (int)MathUtil.scale(enrg, 0, 1, 1, 20);
		d.boxesCountDom = new Domain(boxes, boxes);
		d.boxesMinDim = new Dimension((int)MathUtil.scale(enrg, 0, 1, 1, 20), (int)MathUtil.scale(enrg, 0, 1, 1, 20));
		d.boxesMaxDim = new Dimension((int)MathUtil.scale(enrg, 0, 1, 20, Math.max(iw, ih)), (int)MathUtil.scale(enrg, 0, 1, 20, Math.max(iw, ih)));
		d.boxesPointMin = new Point(-100, -100);
		d.boxesPointMax = new Point(iw+100, ih+100);
		
		
		
		d.palette = ColorPalette.SPA_EARTH;
		String prefix;
		double valence = features.spotifyanalysis.valence;
		double deg = RYBColorWheel.heat(valence);
		d.palette = RYBColorWheel.adjacent(deg, valence*90);
		if (valence < 0.3) {
			prefix = "sad";
		} 
		else if (valence < 0.5) {
			prefix = "pastel";
		} 
		else if (valence < 0.7) {
			prefix = "love";
		} 
		else {
			prefix = "happy";
		}
		
		try {
			d.palette = ColorPalette.getRandomStartsWith(prefix);
		} catch (Exception e) {
			throw new RuntimeException("NOPE!");
		}
		
		if (features.spotifyanalysis.acousticness > 0.7) {
			d.palette = ColorPalette.NATURE3;
		}
		
		return d;
	}
	
	
	
	
}
