package creim.graphics.colors;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.lang.reflect.Field;
import java.util.ArrayList;
import javalib.util.RandomUtil;
import javax.swing.JFrame;
import javax.swing.JPanel;



public class ColorPalette {
	
	// TODO: scrape color palettes from http://www.color-hex.com/color-palettes/popular.php
	
	// RGB
	public static final Color[] DARK_RED   = {new Color(255,0,0), new Color(191,0,0), new Color(128,0,0), new Color(64,0,0), new Color(0,0,0)};
	public static final Color[] DARK_GREEN = {new Color(0,255,0), new Color(0,191,0), new Color(0,128,0), new Color(0,64,0), new Color(0,0,0)};
	public static final Color[] DARK_BLUE  = {new Color(0,0,255), new Color(0,0,191), new Color(0,0,128), new Color(0,0,64), new Color(0,0,0)};
	
	// CALM
	public static final Color[] SPA_EARTH = {new Color(198,195,134), new Color(195,238,231), new Color(91,57,30), new Color(135,198,195), new Color(102,187,174) };
	
	// MAD
	

	// SAD
	
	
	// HAPPY
	
	
	// DARK
	
	
	// LIGHT
	
	
	// MIXED, DISTURBED
	
	// sad
	public static final Color[] SAD1 = {new Color(57,127,166), new Color(227,212,163), new Color(216,137,129), new Color(229,163,91), new Color(162,140,135) };
	public static final Color[] SAD2 = {new Color(42,59,144), new Color(44,52,92), new Color(12,13,73), new Color(24,58,35), new Color(15,15,24) };
	public static final Color[] SAD3 = {new Color(44,90,77), new Color(28,113,131), new Color(53,141,121), new Color(149,210,169), new Color(141,206,188) };
	public static final Color[] SAD4 = {new Color(52,84,103), new Color(16,20,66), new Color(31,107,101), new Color(57,53,81), new Color(29,78,122) };
	public static final Color[] SAD5 = {new Color(36,36,36), new Color(84,68,68), new Color(118,118,97), new Color(129,146,121), new Color(193,190,132) };
	public static final Color[] SAD6 = {new Color(142,162,165), new Color(135,149,159), new Color(128,128,144), new Color(123,116,144), new Color(111,100,133) };

	// happy
	public static final Color[] HAPPY1 = {new Color(54,167,245), new Color(255,234,71), new Color(232,61,81), new Color(255,206,161), new Color(34,228,73) };
	public static final Color[] HAPPY2 = {new Color(255,15,92), new Color(123,212,203), new Color(86,176,193), new Color(40,146,219), new Color(236,250,251) };
	public static final Color[] HAPPY3 = {new Color(179,225,251), new Color(171,255,196), new Color(158,255,111), new Color(220,223,47), new Color(216,129,56) };
	public static final Color[] HAPPY4 = {new Color(175,225,164), new Color(210,231,186), new Color(249,255,200), new Color(249,217,179), new Color(242,182,141) };
	public static final Color[] HAPPY5 = {new Color(255,190,79), new Color(107,210,219), new Color(14,167,181), new Color(12,69,125), new Color(232,112,42) };

	// pastel
	public static final Color[] PASTEL1 = {new Color(249,200,255), new Color(231,188,255), new Color(200,248,255), new Color(166,255,199), new Color(255,235,185) };
	public static final Color[] PASTEL2 = {new Color(184,140,140), new Color(221,173,173), new Color(214,199,199), new Color(159,185,191), new Color(174,200,206) };
	public static final Color[] PASTEL3 = {new Color(217,239,240), new Color(155,200,201), new Color(208,225,205), new Color(187,206,184), new Color(159,191,171) };
	public static final Color[] PASTEL4 = {new Color(255,154,85), new Color(255,234,108), new Color(84,255,251), new Color(231,178,255), new Color(137,255,204) };
	public static final Color[] PASTEL5 = {new Color(175,225,164), new Color(210,231,186), new Color(249,255,200), new Color(249,217,179), new Color(242,182,141) };
	public static final Color[] PASTEL6 = {new Color(239,244,200), new Color(220,223,196), new Color(208,214,192), new Color(193,210,196), new Color(179,206,198) };

	// love
	public static final Color[] LOVE1 = {new Color(206,68,68), new Color(101,1,92), new Color(255,123,210), new Color(101,1,92), new Color(206,68,68) };
	public static final Color[] LOVE2 = {new Color(213,100,227), new Color(240,21,231), new Color(24,119,251), new Color(158,58,193), new Color(228,97,253) };
	public static final Color[] LOVE3 = {new Color(240,166,166), new Color(240,144,183), new Color(214,75,145), new Color(159,96,171), new Color(163,76,255) };
	public static final Color[] LOVE4 = {new Color(196,107,127), new Color(250,236,236), new Color(91,94,139), new Color(237,149,174), new Color(240,62,122) };
	public static final Color[] LOVE5 = {new Color(236,187,229), new Color(195,244,255), new Color(220,191,221), new Color(255,246,194), new Color(186,255,212) };
	public static final Color[] LOVE6 = {new Color(255,131,157), new Color(221,221,221), new Color(204,204,204), new Color(187,187,187), new Color(170,170,170) };

	// calm
	public static final Color[] CALM1 = {new Color(225,94,94), new Color(227,172,87), new Color(236,231,118), new Color(54,135,96), new Color(28,45,81) };
	public static final Color[] CALM2 = {new Color(75,56,50), new Color(133,68,66), new Color(255,244,230), new Color(60,47,47), new Color(190,155,123) };
	public static final Color[] CALM3 = {new Color(232,209,116), new Color(227,158,84), new Color(214,77,77), new Color(77,115,88), new Color(158,214,112) };
	public static final Color[] CALM4 = {new Color(115,211,231), new Color(23,145,163), new Color(109,134,141), new Color(185,199,210), new Color(71,71,71) };

	// cold
	public static final Color[] COLD1 = {new Color(0,119,119), new Color(0,102,102), new Color(0,85,85), new Color(0,68,68), new Color(0,51,51) };
	public static final Color[] COLD2 = {new Color(1,31,75), new Color(3,57,108), new Color(0,91,150), new Color(100,151,177), new Color(179,205,224) };
	public static final Color[] COLD3 = {new Color(179,236,236), new Color(137,236,218), new Color(67,232,216), new Color(64,224,208), new Color(59,214,198) };
	public static final Color[] COLD4 = {new Color(42,77,105), new Color(75,134,180), new Color(173,203,227), new Color(231,239,246), new Color(99,172,229) };
	public static final Color[] COLD5 = {new Color(210,212,220), new Color(175,175,175), new Color(248,248,250), new Color(229,230,235), new Color(192,194,206) };
	public static final Color[] COLD6 = {new Color(3,33,73), new Color(4,44,98), new Color(0,36,72), new Color(2,22,49), new Color(229,229,229) };

	// angry
	public static final Color[] ANGRY1 = {new Color(231,34,34), new Color(201,41,41), new Color(184,47,47), new Color(171,50,50), new Color(150,50,50) };
	public static final Color[] ANGRY2 = {new Color(86,22,22), new Color(79,20,20), new Color(60,12,12), new Color(51,10,10), new Color(39,7,7) };
	public static final Color[] ANGRY3 = {new Color(184,29,48), new Color(35,31,32), new Color(145,143,143), new Color(255,255,255), new Color(255,255,255) };
	public static final Color[] ANGRY4 = {new Color(220,105,0), new Color(235,140,0), new Color(224,48,30), new Color(163,32,32), new Color(96,35,32) };
	public static final Color[] ANGRY5 = {new Color(234,89,40), new Color(195,43,16), new Color(159,56,21), new Color(79,31,18), new Color(24,17,15) };
	public static final Color[] ANGRY6 = {new Color(240,162,14), new Color(251,23,23), new Color(216,190,31), new Color(234,27,27), new Color(216,209,45) };

	// warm
	public static final Color[] WARM1 = {new Color(220,105,0), new Color(235,140,0), new Color(224,48,30), new Color(163,32,32), new Color(96,35,32) };
	public static final Color[] WARM2 = {new Color(102,101,71), new Color(251,46,1), new Color(111,203,159), new Color(255,226,138), new Color(255,254,179) };
	public static final Color[] WARM3 = {new Color(255,78,80), new Color(252,145,58), new Color(249,214,46), new Color(234,227,116), new Color(226,244,199) };
	public static final Color[] WARM4 = {new Color(246,176,88), new Color(253,241,241), new Color(242,219,123), new Color(221,173,58), new Color(195,66,66) };

	// nature
	public static final Color[] NATURE1 = {new Color(173,255,0), new Color(116,214,0), new Color(2,137,0), new Color(0,210,127), new Color(0,255,131) };
	public static final Color[] NATURE2 = {new Color(77,127,23), new Color(107,177,32), new Color(138,228,41), new Color(154,254,46), new Color(174,254,87) };
	public static final Color[] NATURE3 = {new Color(0,152,3), new Color(0,99,2), new Color(71,64,38), new Color(55,94,46), new Color(69,60,22) };
	public static final Color[] NATURE4 = {new Color(166,182,151), new Color(122,135,111), new Color(136,167,142), new Color(194,206,167), new Color(136,163,118) };

	// agressive
	public static final Color[] AGRESSIVE1 = {new Color(255,0,0), new Color(206,255,0), new Color(0,255,244), new Color(37,0,255), new Color(126,65,65) };
	public static final Color[] AGRESSIVE2 = {new Color(185,15,21), new Color(185,94,15), new Color(185,15,106), new Color(106,185,15), new Color(15,106,185) };
	public static final Color[] AGRESSIVE3 = {new Color(222,16,16), new Color(169,104,174), new Color(38,227,228), new Color(181,255,0), new Color(255,132,132) };
	public static final Color[] AGRESSIVE4 = {new Color(187,203,107), new Color(200,0,0), new Color(71,27,7), new Color(27,188,107), new Color(3,53,0) };
	public static final Color[] AGRESSIVE5 = {new Color(197,52,52), new Color(26,146,143), new Color(14,38,64), new Color(53,9,64), new Color(149,68,234) };
	
	
	
	public static int getPaletteCount() {
		Field[] fields = ColorPalette.class.getDeclaredFields();
		return fields.length;
	}
	
	
	
	public static String getPaletteNameByIndex(int index) throws Exception {
		Field[] fields = ColorPalette.class.getDeclaredFields();
		Field field = fields[index % fields.length];
		return field.getName();
	}
	
	public static Color[] getPaletteByIndex(int index) throws Exception {
		Field[] fields = ColorPalette.class.getDeclaredFields();
		Field field = fields[index % fields.length];
		Color[] palette = (Color[])(field.get(null));
		return palette;
	}
	
	
	public static Color[] getRandomPalette() {
		try {
			Field[] fields = ColorPalette.class.getDeclaredFields();
			Field field = fields[RandomUtil.RNG.nextInt(fields.length)];
			Color[] palette = (Color[])(field.get(null));
			return palette;
		} catch (Exception e) {
			return generateRandomPalette();
		}
	}
	
	
	public static Color[] getRandomStartsWith(String prefix) throws Exception {
		prefix = prefix.toUpperCase();
		Field[] fields = ColorPalette.class.getDeclaredFields();
		ArrayList<Field> matching = new ArrayList<>();
		for (Field f : fields) {
			if (f.getName().startsWith(prefix))
				matching.add(f);
		}
		if (matching.isEmpty())
			return null;
		Field selected = matching.get(RandomUtil.nextInt(matching.size()));
		Color[] palette = (Color[])(selected.get(null));
		return palette;
	}
	
	
	public static Color[] generateRandomPastelPalette() {
		Color[] palette = new Color[5];
		
		for (int i = 0; i < palette.length; i++) {
			palette[i] = ColorUtil.randomPastel();
		}
		
		return palette;
	}
	
	
	public static Color[] generateRandomPalette() {
		Color[] palette = new Color[5];
		
		for (int i = 0; i < palette.length; i++) {
			palette[i] = ColorUtil.randomColor(true);
		}
		
		return palette;
	}
	
	
	public static Color[] generateRandomAdjacentPalette() {
		return generateRandomAdjacentPalette(RandomUtil.nextInt(0, 360), RandomUtil.nextInt(5, 72));
	}
		
	public static Color[] generateRandomAdjacentPalette(int deg, int dist) {
		Color[] palette = new Color[5];
		
		float sat = RandomUtil.nextFloat(0.0f, 1.0f);
		float bri = RandomUtil.nextFloat(0.0f, 1.0f);
		
		palette[0] = Color.getHSBColor((float)(deg+dist)/360.0f, sat, bri);
		palette[1] = Color.getHSBColor((float)(deg+dist/2f)/360.0f,   sat, bri);
		palette[2] = Color.getHSBColor((float)(deg)/360.0f,        sat, bri);
		palette[3] = Color.getHSBColor((float)(deg-dist/2f)/360.0f,   sat, bri);
		palette[4] = Color.getHSBColor((float)(deg-dist)/360.0f, sat, bri);
		
		return palette;
	}
	
	public static Color[] generateFullyRandomAdjacentPalette() {
		return generateFullyRandomAdjacentPalette(RandomUtil.nextInt(0, 360), RandomUtil.nextInt(5, 72));
	}
	
	public static Color[] generateFullyRandomAdjacentPalette(int deg, int dist) {
		return generateFullyRandomAdjacentPalette(deg, dist, 0f, 1f, 0f, 1f);
	}
	
	public static Color[] generateFullyRandomAdjacentPalette(int deg, int dist, float saturation, float brightness) {
		Color[] palette = new Color[5];
		
		palette[0] = Color.getHSBColor((float)(deg+dist)/360.0f,    saturation, brightness);
		palette[1] = Color.getHSBColor((float)(deg+dist/2f)/360.0f, saturation, brightness);
		palette[2] = Color.getHSBColor((float)(deg)/360.0f,         saturation, brightness);
		palette[3] = Color.getHSBColor((float)(deg-dist/2f)/360.0f, saturation, brightness);
		palette[4] = Color.getHSBColor((float)(deg-dist)/360.0f,    saturation, brightness);
		
		return palette;
	}
	
	public static Color[] generateFullyRandomAdjacentPalette(int deg, int dist, float smin, float smax, float bmin, float bmax) {
		Color[] palette = new Color[5];
		
		palette[0] = Color.getHSBColor((float)(deg+dist)/360.0f, RandomUtil.nextFloat(smin, smax), RandomUtil.nextFloat(bmin, bmax));
		palette[1] = Color.getHSBColor((float)(deg+dist/2f)/360.0f,   RandomUtil.nextFloat(smin, smax), RandomUtil.nextFloat(bmin, bmax));
		palette[2] = Color.getHSBColor((float)(deg)/360.0f,        RandomUtil.nextFloat(smin, smax), RandomUtil.nextFloat(bmin, bmax));
		palette[3] = Color.getHSBColor((float)(deg-dist/2f)/360.0f,   RandomUtil.nextFloat(smin, smax), RandomUtil.nextFloat(bmin, bmax));
		palette[4] = Color.getHSBColor((float)(deg-dist)/360.0f, RandomUtil.nextFloat(smin, smax), RandomUtil.nextFloat(bmin, bmax));
		
		return palette;
	}
	
	
	public static Color[] generateRandomRYBAdjacentPalette() {
		float bri = RandomUtil.nextFloat(0.5f, 1.0f);
		
		Color[] palette = RYBColorWheel.adjacent(RandomUtil.nextInt(0, 360), 15);
		
		for (int i = 0; i < palette.length; i++) {
			palette[i] = palette[i].brighter();
		}
		
		return palette;
	}
	
	
	public static String toString(Color[] palette) {
		StringBuilder sb = new StringBuilder();
		sb.append("ColorPalette: [");
		for (Color c : palette) {
			sb.append(toString(c));
			sb.append(", ");
		}
		sb.substring(0, sb.length()-2);
		sb.append("]");
		return sb.toString();
	}
	
	
	public static Color[] fromToString(String tostring) {
		String clean = tostring.replaceAll("(\\s|\\(|\\))", "");
		String[] parts = clean.split(",");
		int nums = 0;
		for (int i = 0; i < parts.length; i++) {
			if (!parts[i].isEmpty())
				nums++;
		}
		
		Color[] palette = new Color[nums/3];
		int k = 0;
		for (int i = 0; i < palette.length; i++) {
			int r = Integer.parseInt(parts[k+0]);
			int g = Integer.parseInt(parts[k+1]);
			int b = Integer.parseInt(parts[k+2]);
			palette[i] = new Color(r, g, b);
			k += 3;
		}
		return palette;
	}
	
	
	public static String toString(Color color) {
		return String.format("(%3d,%3d,%3d)", color.getRed(),color.getGreen(),color.getBlue());
	}
	

	
	public static class PaletteFrame extends JFrame {
		public PaletteFrame() {
			this(null);
		}
		public PaletteFrame(String name) {
			super();
			if (name != null) {
				super.setTitle(name);
			}
			super.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		}
		public void set(Color[] colors) {
			super.setLayout(new GridLayout(1, colors.length));
			for (Color color : colors) {
				JPanel panel = new JPanel();
				panel.setBackground(color);
				super.add(panel);
			}
			super.pack();
			super.setSize(new Dimension(100*colors.length+1, 100));
			super.setLocationRelativeTo(null);
			super.setVisible(true);
		}
	}
	
	
	/*
	Combinations of individual colours

	    White: combines with everything, especially blue, red and black.
	    Beige: combines with blue, brown, emerald, black, red, white.
	    Gray: combines with fuchsia, red, violet, pink, blue.
	    Pink: combines with brown, white, mint green, olive, gray, turquoise, light blue.
	    Fuchsia (dark pink): combines with gray, yellow-brown, lime, mint green, brown.
	    Red: combines with yellow, white, fulvous, green, blue, black.
	    Tomato-red: combines with cyan, mint green, sand, creamy-white, gray.
	    Cherry-red: combines with azure, gray, light-orange, sandy, pale-yellow, beige.
	    Raspberry-red: combines with white, black, damask rose.
	    Brown: combines with bright-cyan, cream, pink, fawn, green, beige.
	    Light-brown: combines with pale-yellow, cream-white, blue, green, purple, red.
	    Dark-brown: combines with lime-yellow, cyan, mint green, purple-pink, lime.
	    Reddish-brown: combines with pink, dark-brown, blue, green, purple.
	    Orange: combines with cyan, blue, lilac, violet, white, black.
	    Light-orange: combines with gray, brown, olive.
	    Dark-orange: combines with pale-yellow, olive, brown, cherry.
	    Yellow: combines with blue, lilac, light-cyan, violet, gray, black.
	    Lemon-yellow: combines with cherry-red, brown, blue, gray.
	    Pale-yellow: combines with fuchsia, gray, brown, shades of red, yellowish brown, blue, purple.
	    Golden yellow: combines with gray, brown, azure, red, black.
	    Olive: combines with orange, light-brown, brown.
	    Green: combines with golden-brown, orange, salad green, yellow, brown, gray, cream, black, creamy-white.
	    Salad green: combines with brown, yellowish-brown, fawn, gray, dark-blue, red, gray.
	    Turquoise: combines with fuchsia, cherry-red, yellow, brown, cream, dark-violet.
	    Electric colors: combines with golden-yellow, brown, light brown, gray, or silver.
	    Cyan: combines with red, gray, brown, orange, pink, white, yellow.
	    Dark-blue: combines with light-lilac, cyan, yellowish-green, brown, gray, pale-yellow, orange, green, red, white.
	    Lilac: combines with orange, pink, dark-violet, olive, gray, yellow, white.
	    Dark-violet: combines with golden-brown, pale-yellow, gray, turquoise, mint green, light-orange.
	    Black is a universal colour — it looks elegant in any combination, especially with orange, pink, salad green, white, red, mauvish, or yellow.
	*/
}
