package creim.gui;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JFrame;
import javax.swing.JPanel;



public class ColorFrame extends JFrame {
		
	private Color bg;
	private ColorPanel panel;

	public ColorFrame(Color c) {
		super();
		panel = new ColorPanel(this, c);
		panel.setPreferredSize(new Dimension(200, 200));
		
		super.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		super.add(panel);
		super.pack();
	}

	
	
	
	private class ColorPanel extends JPanel {

		private Color c;
		private Component parent;
		
		public ColorPanel(Component parent, Color c) {
			this.c = c;
			this.parent = parent;
		}
		
		@Override
		public void paint(Graphics g) {
			Graphics2D g2 = (Graphics2D) g;
			super.paint(g2);
			g2.setColor(c);
			g2.fillRect(0, 0, parent.getWidth(), parent.getHeight());
		}
	}
}
