package creim.oldea;

import creim.art.painter.Painter;
import eval.ea.EA;
import eval.models.Genotype;
import eval.models.Phenotype;
import eval.models.Population;
import eval.util.Config;
import java.awt.Color;
import java.awt.Dimension;
import javalib.util.RandomUtil;
import creim.graphics.colors.ColorPalette;
import org.apache.commons.collections4.list.TreeList;



public class ArtEA extends EA {

	
	public ArtEA(Config cfg) {
		super(cfg);
	}
	
	

	@Override
	public Population generateInitalPopulation(int size) {
		Dimension imagedim = new Dimension(cfg.getInt("image_width"), cfg.getInt("image_height"));
		Color[] palette;
		int margin = (int)(Math.max(imagedim.width, imagedim.height) * 0.1);
		
		try {
			palette = ColorPalette.getRandomPalette();
			//palette = Palette.ANGRY4;
		} catch (Exception e) {
			palette = ColorPalette.generateRandomPastelPalette();
		}
		
		Population pop = new Population(size);
		for (int i = 0; i < size; i++) {
			
			int num_models = RandomUtil.nextInt(50);
			TreeList<Painter> painters = new TreeList<>();
			for (int j = 0; j < num_models; j++) {
				Painter painter = Painter.randomPainter(imagedim, margin, palette);
				painters.add(painter);
			}
			ArtGenotype g = new ArtGenotype(painters, imagedim, margin, palette);
			ArtPhenotype p = new ArtPhenotype(g);
			pop.add(p);
		}
		
		return pop;
	}
	

	@Override
	public Phenotype generatePhenotype(Genotype g) {
		ArtPhenotype p = new ArtPhenotype((ArtGenotype)g);
		return p;
	}
	
}
