package master.tests.artist;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.io.File;
import javalib.util.RandomUtil;
import javax.imageio.ImageIO;
import creim.analysis.image.ImageAnalyzer;
import creim.art.artist.Artist;
import creim.gui.ColorFrame;
import creim.graphics.colors.RYBColorWheel;
import creim.graphics.effect.BlurEffect;
import creim.graphics.effect.OilifyEffect;
import creim.art.painter.ClearPainter;
import creim.art.painter.StraightBrushPainter;
import creim.util.Logger;



public class TestArtist1 extends Artist {
	
	public TestArtist1(int width, int height) {
		super(width, height);
	}

	public void load(File imagefile) {
		try {
			super.image = ImageIO.read(imagefile);
		} catch (Exception e) {
			throw new RuntimeException("shiet");
		}
	}

	@Override
	public BufferedImage paint() {
		
		ClearPainter cp = new ClearPainter(width, height, Color.BLACK);
		cp.paintOn(image);
		
		Logger.info("Strokes ...");
		Color[] palette = RYBColorWheel.adjacent(240, 90);
		
		
		for (int i = 0; i < 90; i++) {
			int x = RandomUtil.nextInt(-50, width+50);
			int y = RandomUtil.nextInt(-50, height+50);
			int w = RandomUtil.nextInt(5, 500);
			int h = RandomUtil.nextInt(5, 1000);
			double a = RandomUtil.nextDouble(0, 360);
			
			StraightBrushPainter p = new StraightBrushPainter(x, y, w, h, palette[RandomUtil.nextInt(palette.length)], a);
			p.paintOn(image);
		}
		
		Logger.info("Oil ...");
		OilifyEffect ef = new OilifyEffect(image, 5, 25);
		ef.applyInplace();
		
		Logger.info("Blur ...");
		BlurEffect bf = new BlurEffect(image, 1);
		bf.applyInplace();
		
		return image;
	}

	
	public static void main(String[] args) {
		TestArtist1 t = new TestArtist1(1400, 800);
		t.paint();
		t.display(Color.WHITE);
		BufferedImage out = t.getImage();
		ImageAnalyzer ia = new ImageAnalyzer(out);
		System.out.println(ia.percentOfColor(Color.red, 0));
		
		Color mean = ia.meanColor();
		ColorFrame cf = new ColorFrame(mean);
		cf.setVisible(true);
		System.out.println(ia.colorVariation());
	}
}
