package master.tests.software;

import java.awt.Dimension;
import java.awt.image.BufferedImage;
import java.io.File;
import javax.imageio.ImageIO;
import creim.Config;
import creim.analysis.audio.AudioFileAnalyzer;
import creim.gui.ImageFrame;
import creim.graphics.SpectrumImage;
import java.io.FilenameFilter;
import java.util.Arrays;
import javalib.util.RandomUtil;



public class AudioFileAnalyzerTest {
	
	public static void main(String[] args) throws Exception {
		File[] files = new File("spotify").listFiles();
		File[] songfile = files[RandomUtil.nextInt(files.length)].listFiles((File dir, String name) -> {
			return name.endsWith(".mp3");
		});
		System.out.println(songfile[0]);
		AudioFileAnalyzer afa = new AudioFileAnalyzer(songfile[0]);
		
		double[][] data = afa.logSpectrum(true);
		
		Dimension dim = new Dimension(1800, 800);
		BufferedImage specimg = SpectrumImage.create(dim.width, dim.height, data);
		
		ImageFrame specframe = new ImageFrame(specimg);
		specframe.setVisible(true);

	}
}
